import { Button, Descriptions,Popconfirm, Row, Col, Form,Modal, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude,extendIgnoreDataRule, setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import stylesStep from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from "antd/lib/index";
import FormPage from '../../../components/FormPage'
class PE022ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            BtnAgreeDisplay: 'none',
            tmpData: {},
        };
    };

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'PE/PESafetyMonitorPlan/IdentityUpdate',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('确认成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined"&&typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let that=this;
        let json = initFilter(that.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendIgnoreDataRule(json)
       that.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'PE/PESafetyMonitorPlan/GetRecordEdit',
            onComplete: (ret) => {
                if (ret) {
                    if(that.props.data && that.props.data.loadDataDeal)
                    {
                        that.props.data.loadDataDeal(1);
                    }
                    that.setState({ data: ret });
                    if (that.props.data.tableKey==="2" ||that.props.data.tableKey===undefined) {
                        that.setState({ BtnAgreeDisplay: 'none' })
                    }else{
                        that.setState({ BtnAgreeDisplay: 'inline' })
                    }
                    this.onClickApprove(false);
                    //归档才显示打印和导出按钮
                    // if(ret.PRE_MEETING_STATUS==5){
                    //     this.setState({ isFinished: 'inline' })
                    // }
                }
                else
                { message.error('请先尝试刷新，若仍然加载失败，请联系管理员排查!');}
            }
        });
    }

    onTableBtnExport() {
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, "年度安全绩效监测记录.xlsx")
    }

    onClickApprove=(appVisible)=>{
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true,key:guid(),param:this.props.data.param,appVisible:appVisible,BtnAgreeDisplay:'inline'},
            formCode: "PF123",
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    render() {
        const { data } = this.state;
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        // let aaa = Math.random();
        return <div>
            <div style={{ padding: '10px' }}>
            <Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px'}} icon="export">审批详情</Button>
                <ReactToPrint
                    trigger={() => <Button style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5?"inline":"none" }} type={'default'} icon={'printer'} >打印</Button>}
                    content={() => this.componentRef}
                />
                <Button onClick={() => this.onTableBtnExport()} icon="export" style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5?"inline":"none" }}>导出</Button>
                {/* <Button type="primary" style={{marginLeft: '8px', display: this.state.BtnAgreeDisplay }} onClick={() => this.onTableBtnAgree()} icon="check" >已阅</Button> */}
            </div>
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 style={{ textAlign: 'center', margin: '15px' }}>年度安全绩效监测记录</h1>
                {
                     data ?
                     <div>
                        <Descriptions size="middle" bordered className={stylesStep.description}>
                            <Descriptions.Item label="发起时间">{moment(data.CREATE_TIME).format('YYYY-MM-DD')}</Descriptions.Item>
                            <Descriptions.Item label="发起部门">{data.Nav_Department ? data.Nav_Department.NAME : ''}</Descriptions.Item>
                            <Descriptions.Item label="发起人员">{data.Nav_User ? data.Nav_User.NAME : ''}</Descriptions.Item>
                            <Descriptions.Item label="年度">{data.YEAR}</Descriptions.Item>
                            <Descriptions.Item label="监测程序">{data.MONITOR_PROGRAM}</Descriptions.Item>
                            <Descriptions.Item label="监测范围位置">{data.MONITOR_RANGE}</Descriptions.Item>
                            <Descriptions.Item label="资源配备">{data.RESOURCES}</Descriptions.Item>
                        </Descriptions>
                     </div>:null
                }
                 {
                    data ?  <table style={{ width: '100%', textAlign: 'left'}} className={stylesStep.PrintForm1}>
                    <tr>
                    <td  style={{width:"150px"}} className={stylesStep.fontBold}>序号</td>
                    <td className={stylesStep.fontBold}>监测项目</td>
                    <td className={stylesStep.fontBold}>监测内容</td>
                    <td className={stylesStep.fontBold}>监测标准</td>
                    <td className={stylesStep.fontBold}>监测频率</td>
                    <td className={stylesStep.fontBold}>监测方法与技术</td>
                    <td className={stylesStep.fontBold}>监测部门</td>
                    <td className={stylesStep.fontBold}>负责人员</td>
                    <td className={stylesStep.fontBold}>监测实况</td>
                    <td className={stylesStep.fontBold}>结果论述</td>
                    <td className={stylesStep.fontBold}>监测人员</td>
                    </tr>
                    {
                                   data.Nav_Details && data.Nav_Details.map((item,i)=>{
                                        return <tr>
                                            <td>
                                                {i+1}
                                            </td>
                                            <td>
                                                {item.Nav_Project?.NAME}
                                            </td>
                                            <td>
                                                {item.CONTENTS}
                                            </td>
                                            <td>
                                                {
                                                  item.STANDARD
                                                }
                                            </td>
                                            <td>
                                                {enums.PTAssessmentCycleEnums.enums[item?.ASSESSMENT_CYCLE]}
                                            </td>
                                            <td>
                                                {
                                                  item.METHOD
                                                }
                                            </td>
                                            <td>
                                                {item.Nav_Department?.NAME}
                                            </td>
                                            <td>
                                                {item.Nav_User?.NAME}
                                            </td>
                                            <td>
                                                {item.MONITOR_LIVE}
                                            </td>
                                            <td>
                                            {enums.PTResultDiscussEnums.enums[item?.RESULT_DISCUSS]}
                                            </td>
                                            <td>
                                            {
                                item.Nav_MonitorUser && item.Nav_MonitorUser.map((item2, i) => {
                                    if (i == (item.Nav_MonitorUser.length - 1)) {
                                        if (item2.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'> {item2.Nav_User?.NAME}</label>
                                        else
                                            return item2.Nav_User.NAME
                                    } else {
                                        if (item2.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'>{item2.Nav_User?.NAME + '  '}</label>
                                        else
                                            return item2.Nav_User.NAME + '  '
                                    }
                                })
                            }
                                            </td>
                                        </tr>
                                    })
                                }
                    </table>:null 
                }
                <FormPage {...this.state.tmpData} />
            </div>
        </div>
    }

}

export default connect(({ login,app }) => ({ login,app }))(PE022ShowPrint) 